package com.p3p.serialecho.packets;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import com.p3p.simpleserialprotocol.SerialPacket;

public class TestPacket {
	int type;
	int dataubyte;
	int dataushort;
	long datauint;
	float datafloat;
	ByteBuffer buffer;
	
	public TestPacket(int type,	int dataubyte,int dataushort,long datauint,float datafloat){
		this.type = type;
		this.dataubyte = dataubyte;
		this.dataushort = dataushort;
		this.datauint = datauint;
		this.datafloat = datafloat;
	}
	
	public TestPacket(SerialPacket data) {
		buffer = ByteBuffer.wrap(data.data);
		buffer.order(ByteOrder.LITTLE_ENDIAN);
		type = buffer.get() & 0xFF;
		dataubyte = buffer.get() & 0xFF;
		dataushort =  (int)(buffer.getShort() & 0xFFFF);
		datauint = (long)(buffer.getInt() & 0xFFFFFFFFl);
		datafloat = buffer.getFloat();
	}
	
	public String toString(){
		return new String("" + type + ", " 
							 + dataubyte + ", "
							 + dataushort + ", "
							 + datauint + ", "
							 + datafloat);
	}
	
	public byte[] encodePacket(){
		byte[] data = new byte[12];
		buffer = ByteBuffer.wrap(data);
		buffer.order(ByteOrder.LITTLE_ENDIAN);
		buffer.put((byte)type);
		buffer.put((byte)dataubyte);
		buffer.putShort((short)dataushort);
		buffer.putInt((int)((long)(datauint) & 0xFFFFFFFF));
		buffer.putFloat(datafloat);
		return buffer.array();
	}
}